#include "stm32f10x.h"
#include "LCD5110.h"
#include "delay.h"
#include "Pixel_EN.h"
#include "Pixel_CH.h"
//-------------------------------------------------------------------
//	Nokia5510ָ
//  D7  D6  D5  D4  D3  D2  D1  D0
//  0   0   1   0   0   PD  V   H
//                      |   |   |_______1->չָ  0->ָ
//                      |   |___________1->ֱѰַ    0->ˮƽѰַ 
//                      |_______________1->͹ģʽ  0->ģʽ
//-------------------------------------------------------------------
//	ʾģʽ
//  D7  D6  D5  D4  D3  D2  D1  D0
//  0   0   0   0   1   D   0   E
//                      |       |_______0    0    1    1
//                      |_______________0    1    0    1
//                                        ȫ ת
//-------------------------------------------------------------------

/********************************************************************************************************************************************
@f_name: void LCD5110_GPIOInit(void)
@brief:	 ʼӲ˿
@param:	 None
@return: None
*********************************************************************************************************************************************/
void LCD5110_GPIOInit(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
 	RCC_APB2PeriphClockCmd(LCDRCC_CLK, ENABLE);

	GPIO_InitStructure.GPIO_Pin =GPIO_Pin_All;
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
 	GPIO_Init(LCD_CTRL_PORT, &GPIO_InitStructure);

	LCD5110_Init();
}
/********************************************************************************************************************************************
@f_name: void LCD5110_Init(void)
@brief:	 Һʼ
@param:	 None
@return: None
*********************************************************************************************************************************************/
void LCD5110_Init(void)
{
	//λLCD_͵ƽ
	LCD_RST_L;		
	delay_ms(1);
	LCD_RST_H;
	
	//λнӿ_ߵƽ
	LCD_CE_H; 
	delay_ms(1);
	LCD_CE_L; 

	//LCD
    LCD5110_Send(0x21, DC_CMD);	//ʹչLCDģʽ
    LCD5110_Send(0xC8, DC_CMD);	//ƫõѹ
    LCD5110_Send(0x06, DC_CMD);	//¶У
    LCD5110_Send(0x13, DC_CMD);	//1:48
    LCD5110_Send(0x20, DC_CMD);	//ʹû
    LCD5110_Send(0x0C, DC_CMD);	//趨ʾģʽʾ

	LCD5110_SetContrast(68);    //ԱȶΪ68
}
/********************************************************************************************************************************************
@f_name: void LCD5110_SetContrast(u8 contrast)
@brief:	 LCDԱȶ(ԱȶȷΧ: 0~127)
@param:	 None
@return: None
*********************************************************************************************************************************************/
void LCD5110_SetContrast(u8 contrast)
{
    LCD5110_Send(0x21, DC_CMD);
    LCD5110_Send(0x80 | contrast, DC_CMD);
    LCD5110_Send(0x20, DC_CMD);
}
/********************************************************************************************************************************************
@f_name: void LCD5110_SetXY(u8 X, u8 Y)
@brief:	 LCDǰ	  
@param:	 X:0~83   Y:1~5  
@return: None
*********************************************************************************************************************************************/
void LCD5110_SetXY(u8 X, u8 Y)
{
	if(X>83) X=83;
	if(Y>5)	 Y=5;
	LCD5110_Send(0x40 | Y, DC_CMD);    // 
    LCD5110_Send(0x80 | X, DC_CMD);    // 
}
/********************************************************************************************************************************************
@f_name: void LCD5110Clear(void)
@brief:	 LCDȫ
@param:	 None
@return: None
*********************************************************************************************************************************************/
void LCD5110Clear(void)
{
	u16 i;	
	LCD5110_Send(0x0c, DC_CMD);
    LCD5110_Send(0x80, DC_CMD);	
	for (i=0; i<504; i++)
	LCD5110_Send(0, DC_DATA);	
}
/********************************************************************************************************************************************
@f_name: void LCD5110ClearPart(u8 X,u8 Y,u8 L,u8 H)
@brief:	 LCD
@param:	 u8 X,u8 Y,        u8 L,       u8 H
@return: None
*********************************************************************************************************************************************/
void LCD5110ClearPart(u8 X,u8 Y,u8 L,u8 H)
{
	u16 i,j;
	
	LCD5110_Send(0x0c, DC_CMD);
    LCD5110_Send(0x80, DC_CMD);
	
	for (i=Y; i<Y+H+1; i++)
    	for(j=X;j<X+L+1;j++)
         { 
		 	LCD5110_SetXY(j,i);
	     	LCD5110_Send(0, DC_DATA);	
         }
}
/********************************************************************************************************************************************
@f_name: void LCD5110_Send(u8 data, DCType dc)
@brief:	  LCD
@param:	 u8 data:          DCType dc	  DC_CMD  = 0,	//д	DC_DATA = 1		//д
@return: None
*********************************************************************************************************************************************/
void LCD5110_Send(u8 data, DCType dc)
{
	u8 i=8;

	if (dc==DC_CMD)
		LCD_DC_CMD;	//
	else
		LCD_DC_DATA;//
	
//	LCD_CE_L; //Enable LCD
	
	while (i--)
	{
		LCD_CLK_L;
		if(data&0x80)
			LCD_MOSI_H;	/* MSB first */
		else 
			LCD_MOSI_L;
		LCD_CLK_H;
		data <<= 1;		/* Data shift */
	}
	
//	LCD_CE_H; //Disable LCD
}
/********************************************************************************************************************************************
@f_name: void LCD5110WriteChar(u8 X, u8 Y,u8 ascii)
@brief:	 LCDдһӢַ
@param:	 u8 X, u8 Y,                u8 ascii:ӢASCII
@return: None
*********************************************************************************************************************************************/
void LCD5110WriteChar(u8 X, u8 Y,u8 ascii)
{   
    u8 n;
	LCD5110_SetXY(X,Y);
    ascii -= 32; //ASCII-32
	
    for (n=0; n<7; n++)
		LCD5110_Send(Font6x8[ascii][n], DC_DATA);
    
}

/*
void LCD_Write_Char(u8 ascii)
{
    u8 n;
	
    ascii -= 32; //ASCII-32
	
    for (n=0; n<6; n++)
		LCD_Send(Font6x8[ascii][n], DC_DATA);
}
*/
/********************************************************************************************************************************************
@f_name: void LCD5110WriteEnStr(u8 X, u8 Y, u8* s)
@brief:	 LCDдӢַ
@param:	 u8 X:0~83       u8 Y:0~5            u8* s:ַ
@return: None
*********************************************************************************************************************************************/
void LCD5110WriteEnStr(u8 X, u8 Y, u8* s)
{
    while (*s!='\0') 
	{
		LCD5110WriteChar(X,Y,*s++);
		X=X+6;
		if(X>84)
		{ 
			X=0;
			Y=Y+1;
			*s--;
			if(Y>5)	{Y=0;}
		}
	}
}
/********************************************************************************************************************************************
@f_name: void LCD5110ShowNum(u8 X,u16 Y,u32 num)
@brief:	 ʾһ
@param:	 x,y:		 num:ֵ(0~65536); 
@return: None
*********************************************************************************************************************************************/
//m^n
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}

void LCD5110ShowNum(u8 X,u16 Y,u32 num)
{      
	u32 res;   	   
	u8 t=0,t1=0;   
	res=num;
	if(!num)LCD5110WriteChar( X,Y,'0');//ʾ0
	while(res)  //õֳ
	{
		res/=10;
		t++;
	}
	t1=t;
	while(t)	//ʾ
	{
		res=mypow(10,t-1); 	 
	    LCD5110WriteChar(X+(t1-t)*6,Y,(num/res)%10+'0');//ַһ'0'֮ǰ
		t--;
	}				     
} 
/********************************************************************************************************************************************
@f_name: void LCD5110WriteChStr(u8 X, u8 Y,u8 n)
@brief:	 LCDдַ
@param:	 u8 X, u8 Y,u8 n
@return: None
*********************************************************************************************************************************************/
void LCD5110WriteChStr(u8 X, u8 Y,u8 n)
{
	int i;
	LCD5110_SetXY(X,Y);
	for(i = 0;i < 12; i++)//ϰ
	{
		LCD5110_Send(chinese_character[n][i],DC_DATA);
	}
	LCD5110_SetXY(X,Y+1);
	for(i = 12; i < 24; i++)//°
	{LCD5110_Send(chinese_character[n][i],DC_DATA);}
}
	
