#include "LCD1602.h"	
#include "delay.h"
/************************************************************************************************
@f_name: void LCD1602_InitPort(void)
@brief:	 ʼӲ˿
@param:	 None
@return: None
************************************************************************************************/
void LCD1602_InitPort(void)
{  	
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(LCD1602_GPIOCLK | RCC_APB2Periph_AFIO, ENABLE);	
		
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_Disable,ENABLE);    //ѵͨIO
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_CMD; 		
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	 	// 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	 	// ƵΪ50HZ
	GPIO_Init(LCD1602_GPIO, &GPIO_InitStructure);   		// ʼGPIOB˿	   //1602Һݶ˿


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_DAT;	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;	 	// ©
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	 	// ƵΪ50HZ
	GPIO_Init(LCD1602_GPIO, &GPIO_InitStructure);   				// ʼGPIOB˿

	GPIO_Write(LCD1602_GPIO,0xffff);  //GPIOB 16˿ȫΪߵ  
}	
/************************************************************************************************
@f_name: void NOP(void)
@brief:	 ʱ
@param:	 None
@return: None
************************************************************************************************/ 
void NOP(void)
{ u16 i; for(i=0; i<100; i++);} 
/************************************************************************************************
@f_name: u8 lcd1602_bz(void)
@brief:	 LCDæµ״̬
@param:	 None
@return: 1æ    0
************************************************************************************************/ 
u8 lcd1602_bz(void)
{                        
	u8 x;
	LCD_RS(0);  
	LCD_RW(1);  
	LCD_EN(1); 
	NOP();
	NOP();
	x = BUSY ;
	LCD_EN(0); 
	return x; 
}
/************************************************************************************************
@f_name: lcd1602_wcmd(int cmd)
@brief:	 дָݵLCD
@param:	 u8 cmd
@return: None
************************************************************************************************/ 
void lcd1602_wcmd(u8 cmd)
{                          
	while(lcd1602_bz());
	LCD_RS(0); 
	LCD_RW(0); 
	LCD_EN(0); 
	NOP();
	NOP(); 
	LCD1602WriteData(cmd);
	NOP();
	NOP();
	LCD_EN(1); 
	NOP();
	NOP();
	LCD_EN(0); 
}	
/************************************************************************************************
@f_name: void lcd1602_wdat(u8 dat)
@brief:	 дݵLCD
@param:	 u8 dat
@return: None
************************************************************************************************/ 
void lcd1602_wdat(u8 dat) 
{                         
	while(lcd1602_bz());
	LCD_RS(1); //= 1;
	LCD_RW(0); //= 0;
	LCD_EN(0); //= 0;
	LCD1602WriteData(dat);
	NOP();
	NOP();
	LCD_EN(1);// = 1;
	NOP();
	NOP();
	LCD_EN(0);// = 0; 
}
/************************************************************************************************
@f_name: void lcd1602_pos(u8 pos,u8 row)
@brief:	 ʾλ
@param:	 u8 posʾλ		u8 rowʾڼ
@return: None
************************************************************************************************/		
void lcd1602_pos(u8 pos,u8 row)
{
	switch(row)
	{
		case 1:lcd1602_wcmd(0x80|pos);break;  //DDRAMеַ80H,еַ0xc0	
		case 2:lcd1602_wcmd(0xc0|pos);break;  
		default:lcd1602_wcmd(0x80|pos); 	
	}
}
/************************************************************************************************
@f_name: void lcd1602_clr(void)
@brief:	 
@param:	 None
@return: None
************************************************************************************************/
void lcd1602_clr(void)
{
	lcd1602_wcmd(0x01);
	delay_ms(1);
} 
/************************************************************************************************
@f_name: void lcd1602_init(void)		
@brief:	 Һʼ
@param:	 None
@return: None
************************************************************************************************/	
void lcd1602_init(void)		   
{                       
	lcd1602_wcmd(0x38);          //16*2ʾ5*78λ
	delay_ms(5);
	lcd1602_wcmd(0x0c);          //ʾع
	delay_ms(5);
	lcd1602_wcmd(0x06);          //ƶ
	delay_ms(5);
	lcd1602_wcmd(0x01);          //LCDʾ
	delay_ms(5);
}
/************************************************************************************************
@f_name: void strdis(u8 *p)	 
@brief:	 дַ
@param:	 u8 *p ַ׵ַ
@return: None
************************************************************************************************/
void strdis(u8 *p)	  
{			  					
	while(*p!='\0')			    // жǷΪ
	lcd1602_wdat(*(p++));	   // дҪʾ
}
	
	 
